#ifndef Lib_GZipReader_h
#define Lib_GZipReader_h

#include <Slash/Core/IReader.h>

#include <string>

namespace Slash {namespace Core {class IWriter;}}

namespace Lib {

class GZipReader : public virtual Slash::Core::IReader {
public: //Slash::Core::IReader
  virtual bool read(void*,unsigned int,int&);
  virtual bool read(void*,unsigned int,std::string&);
  virtual bool sread(void*,unsigned int,unsigned int&);
  virtual bool rewind(); 
  virtual void disable();
  virtual void enable();
  virtual bool enabled() const;
public:
  static bool available();
public:
  GZipReader(const std::string&,Slash::Core::IWriter&);
  virtual ~GZipReader();
private:
  Slash::Core::IWriter& fPrinter;
  std::string fFileName;
  void* fFile;
};

}

#endif
