#ifndef Slash_Tools_osc_env_h
#define Slash_Tools_osc_env_h

#include <Slash/Tools/system.h>

namespace Slash {
namespace osc {

inline bool set_env(std::ostream& a_out){
  
  std::string OSC_HOME_DIR;
  if(!Slash::getenv("OSC_HOME_DIR",OSC_HOME_DIR)) {
    a_out << "Slash::osc::set_env :"
          << " Environment variable OSC_HOME_DIR not defined."
          << " You have to setup OpenScientist by sourcing "
          << " the setup script, found in the distribution,"
          << " corresponding to your kind of shell."
          << std::endl;
    return false;
  }

  std::string fs = Slash::file_separator();

  //ONXROOT is used to find <ref> common .onx files.
  std::string ONXROOT = OSC_HOME_DIR + fs + "Resources" + fs + "OnX";        
  if(!Slash::putenv("ONXROOT",ONXROOT)) return false;

  if(!Slash::env_path_append
    ("TTFPATH",OSC_HOME_DIR+fs+"Resources"+fs+"HEPVis"+fs+"fonts")) return false;
  
#ifdef WIN32
  //Slash::putenv("ONX_HAS_PYTHON","no")
#else
#ifdef __APPLE__
  Slash::putenv("ONX_HAS_PYTHON","yes");
#else  // Linux
  //Slash::putenv("ONX_HAS_PYTHON","no")
#endif
#endif

  if(!Slash::env_path_append("PYTHONPATH",
    OSC_HOME_DIR+fs+"Resources"+fs+"OnX"+fs+"scripts"+fs+"Python")) return false;
  if(!Slash::env_path_append("PYTHONPATH",
    OSC_HOME_DIR+fs+"Resources"+fs+"CoinPython"+fs+"scripts")) return false;
  if(!Slash::env_path_append("PYTHONPATH",
    OSC_HOME_DIR+fs+"Resources"+fs+"HEPVis"+fs+"scripts"+fs+"Python")) 
      return false;
  if(!Slash::env_path_append("PYTHONPATH",OSC_HOME_DIR+fs+"bin")) return false;

  return true;
}

}}

#endif
